Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1075047 - Review Request: nodejs-multiparty - A multipart/form-data parser for Node.js which supports streaming
Summary: Review Request: nodejs-multiparty - A multipart/form-data parser for Node.js ...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Tom Hughes
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1075219
Blocks: nodejs-reviews 1003338
TreeView+ depends on / blocked
 
Reported: 2014-03-11 12:01 UTC by Jamie Nguyen
Modified: 2014-03-15 16:36 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-03-15 16:36:06 UTC
tom: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Jamie Nguyen 2014-03-11 12:01:16 UTC
Spec URL: http://jamielinux.fedorapeople.org/connect/nodejs-multiparty.spec
SRPM URL: http://jamielinux.fedorapeople.org/connect/SRPMS/nodejs-multiparty-3.2.3-1.fc21.src.rpm
Fedora Account System Username: jamielinux

Description:
A multipart/form-data parser for Node.js which supports streaming.

Comment 1 Tom Hughes 2014-03-11 18:11:55 UTC
This appears to have a dependency (run time, not just build time) on stream-counter which you don't seem to have filed a request for currently.

Comment 2 Tom Hughes 2014-03-11 18:19:47 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
[!]: %check is present and all tests pass.

I'm getting two test failures, running with npm installed
dependencies:

  1) standalone test-issue-36:
     Error: exited with code 8
      at ChildProcess.<anonymous> (/home/tom/rpm/BUILD/package/test/test.js:49:33)
      at ChildProcess.EventEmitter.emit (events.js:98:17)
      at Process.ChildProcess._handle.onexit (child_process.js:797:12)

  2) standalone test-issue-5:
     Error: exited with code 8
      at ChildProcess.<anonymous> (/home/tom/rpm/BUILD/package/test/test.js:49:33)
      at ChildProcess.EventEmitter.emit (events.js:98:17)
      at Process.ChildProcess._handle.onexit (child_process.js:797:12)

[!]: Rpmlint is run on all installed packages.

Failed due to install failure related to missing dependency on
stream-counter module.

[!]: Unpackaged doc file

The README is not being included in the built package.


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. No licenses
     found. Please check the source files for licenses manually.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 20480 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Rpmlint is run on all installed packages.
     Note: Mock build failed
     See: http://fedoraproject.org/wiki/Packaging/Guidelines#rpmlint
[x]: Spec file according to URL is the same as in SRPM.


Installation errors
-------------------
INFO: mock.py version 1.1.36 starting...
Start: init plugins
INFO: selinux disabled
Finish: init plugins
Start: run
Mock Version: 1.1.36
INFO: Mock Version: 1.1.36
Start: lock buildroot
INFO: installing package(s): /home/tom/1075047-nodejs-multiparty/results/nodejs-multiparty-3.2.3-1.fc21.noarch.rpm
ERROR: Command failed: 
 # ['/usr/bin/yum', '--installroot', '/var/lib/mock/compton-rawhide-x86_64/root/', 'install', '/home/tom/1075047-nodejs-multiparty/results/nodejs-multiparty-3.2.3-1.fc21.noarch.rpm']
Error: Package: nodejs-multiparty-3.2.3-1.fc21.noarch (/nodejs-multiparty-3.2.3-1.fc21.noarch)
           Requires: npm(stream-counter) >= 0.2.0
Error: Package: nodejs-multiparty-3.2.3-1.fc21.noarch (/nodejs-multiparty-3.2.3-1.fc21.noarch)
           Requires: npm(stream-counter) < 0.3
 You could try using --skip-broken to work around the problem
 You could try running: rpm -Va --nofiles --nodigest



Rpmlint
-------
Checking: nodejs-multiparty-3.2.3-1.fc21.noarch.rpm
          nodejs-multiparty-3.2.3-1.fc21.src.rpm
nodejs-multiparty.noarch: W: spelling-error Summary(en_US) multipart -> multiparty, multiplier
nodejs-multiparty.noarch: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-multiparty.noarch: W: spelling-error %description -l en_US multipart -> multiparty, multiplier
nodejs-multiparty.noarch: W: spelling-error %description -l en_US js -> dis, ks, j
nodejs-multiparty.noarch: W: only-non-binary-in-usr-lib
nodejs-multiparty.noarch: W: dangling-symlink /usr/lib/node_modules/multiparty/node_modules/stream-counter /usr/lib/node_modules/stream-counter
nodejs-multiparty.src: W: spelling-error Summary(en_US) multipart -> multiparty, multiplier
nodejs-multiparty.src: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-multiparty.src: W: spelling-error %description -l en_US multipart -> multiparty, multiplier
nodejs-multiparty.src: W: spelling-error %description -l en_US js -> dis, ks, j
nodejs-multiparty.src: W: invalid-url Source1: tests-3.2.3.tar.bz2
2 packages and 0 specfiles checked; 0 errors, 11 warnings.




Requires
--------
nodejs-multiparty (rpmlib, GLIBC filtered):
    nodejs(engine)
    npm(stream-counter)



Provides
--------
nodejs-multiparty:
    nodejs-multiparty
    npm(multiparty)



Source checksums
----------------
http://registry.npmjs.org/multiparty/-/multiparty-3.2.3.tgz :
  CHECKSUM(SHA256) this package     : 73ad3445dee439e7e9c7a8e8b6b50f4dca951f4c59bceb06fd9b048290c431f1
  CHECKSUM(SHA256) upstream package : 73ad3445dee439e7e9c7a8e8b6b50f4dca951f4c59bceb06fd9b048290c431f1


Generated by fedora-review 0.5.1 (bb9bf27) last change: 2013-12-13
Command line :/usr/bin/fedora-review -m compton-rawhide-x86_64 -b 1075047
Buildroot used: compton-rawhide-x86_64
Active plugins: Generic, Shell-api
Disabled plugins: Java, C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 3 Jamie Nguyen 2014-03-11 18:26:36 UTC
(In reply to Tom Hughes from comment #1)
> This appears to have a dependency (run time, not just build time) on
> stream-counter which you don't seem to have filed a request for currently.

Ah sorry. I'd already packaged it but forgot to add it to my list of reviews to open.

Comment 4 Jamie Nguyen 2014-03-11 20:36:56 UTC
I'm only getting one error when running `npm test`:

  1) standalone test-issue-36:
     Error: exited with code 8
      at ChildProcess.<anonymous> (/home/tom/rpm/BUILD/package/test/test.js:49:33)
      at ChildProcess.EventEmitter.emit (events.js:98:17)
      at Process.ChildProcess._handle.onexit (child_process.js:797:12)

This is related to patching out npm(readable-stream), which is a mirror of streams2 from Node 0.10 (readable-stream@1.0.x) and streams3 from Node 0.11 (readable-stream@1.1.x). Not sure if FPC will allow a straight copy of these files/functions from Node core. Looks like a total of around 1700 lines pretty much copy-pasted from Node :(

Patching out readable-stream appeared to be simple at first.... But I just realised that they are using readable-stream@1.1.x :(

Comment 5 Jamie Nguyen 2014-03-11 20:47:08 UTC
Seems like we have three options:

1) Ignore the failing test. I'm really not sure how much impact this will have.

2) Package multiparty@2.1.9 (which uses readable-stream@1.0.x so it can be patched out easily to use Node core). connect@2.14.1 still passes the test suite with multiparty@2.1.9.

3) Open FPC ticket to see if readable-stream can be packaged, but it's not a fork and is a straight copy of a large amount of code so I somehow doubt it will be approved.


What do you think Tom?

Comment 6 Tom Hughes 2014-03-11 22:29:03 UTC
So the second test failure I was seeing is because I was running mocha by hand, while "npm test" applies a ulimit first, and the test in question is testing what happens when it runs out of file descriptors so relies on the lower ulimit. The spec file will presumably need to do the ulimit.

Passing the tests is only a SHOULD anyway, so if you're happy to try and make that the rest of the stack will work despite the failing test then fine. Hopefylly 0.12 will be along soon anyway...

Comment 7 Jamie Nguyen 2014-03-11 22:45:39 UTC
Ok cool. connect@2.14.1 still passes the whole test suite with the current multiparty package so fingers crossed we'll not see any strange problems.

When I find the energy I might open FPC tickets for nodejs-extend and nodejs-readable-stream.

Comment 8 Tom Hughes 2014-03-11 22:52:15 UTC
So the README needs adding to %doc but other than that it looks good, so package approved.

Comment 10 Jamie Nguyen 2014-03-11 22:59:31 UTC
New Package SCM Request
=======================
Package Name: nodejs-multiparty
Short Description: A multipart/form-data parser for Node.js which supports streaming
Owners: jamielinux patches
Branches: f19 f20 el6 
InitialCC:

Comment 11 Gwyn Ciesla 2014-03-12 12:20:05 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.